com.h3c.of.lib.instr

## Enum ActionType

- java.lang.Object
- - java.lang.Enum<ActionType>
  - - com.h3c.of.lib.instr.ActionType

- All Implemented Interfaces:
    OfpCodeBasedEnum, OfpEnum, Serializable, Comparable<ActionType>

      public enum ActionType
      extends Enum<ActionType>
      implements OfpCodeBasedEnum

  Denotes the different actions that can be associated with flow entries, groups or packets.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `COPY_TTL_IN` Copy TTL "inwards" -- from outermost to next-to-outermost; Since 1.1.
    `COPY_TTL_OUT` Copy TTL "outwards" -- from next-to-outermost to outermost; Since 1.1.
    `DEC_MPLS_TTL` Decrement MPLS TTL; Since 1.1.
    `DEC_NW_TTL` Decrement IP TTL; Since 1.1.
    `EXPERIMENTER` Experimenter action; Since 1.1.
    `GROUP` Apply group; Since 1.1.
    `OUTPUT` Output to switch port; Since 1.0.
    `POP_MPLS` Pop the outer MPLS tag; Since 1.1.
    `POP_PBB` Pop the outer PBB service tag (I-TAG); Since 1.3.
    `POP_VLAN` Pop the outer VLAN tag; Since 1.1.
    `PUSH_MPLS` Push a new MPLS tag; Since 1.1.
    `PUSH_PBB` Push a new PBB service tag (I-TAG); Since 1.3.
    `PUSH_VLAN` Push a new VLAN tag; Since 1.1.
    `SET_FIELD` Set a header field using OXM TLV format; Since 1.2.
    `SET_MPLS_TTL` Set MPLS TTL; Since 1.1.
    `SET_NW_TTL` Set IP TTL; Simce 1.1.
    `SET_QUEUE` Set queue id when outputting to a port; Since 1.1.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static Set<ActionType>` | `decodeFlags(int bitmap, ProtocolVersion pv)` Decodes the action type flags, based on the code associated with the flags, and returns the set of corresponding constants.
    `static int` | `encodeFlags(Set<ActionType> flags, ProtocolVersion pv)` Encodes a set of action type flags as a bitmap.
    `int` | `getCode(ProtocolVersion pv)` Returns the code for the constant, under the given protocol version.
    `static ActionType` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static ActionType[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### OUTPUT

          public static final ActionType OUTPUT

      Output to switch port; Since 1.0.

    - #### COPY_TTL_OUT

          public static final ActionType COPY_TTL_OUT

      Copy TTL "outwards" -- from next-to-outermost to outermost; Since 1.1.

    - #### COPY_TTL_IN

          public static final ActionType COPY_TTL_IN

      Copy TTL "inwards" -- from outermost to next-to-outermost; Since 1.1.

    - #### SET_MPLS_TTL

          public static final ActionType SET_MPLS_TTL

      Set MPLS TTL; Since 1.1.

    - #### DEC_MPLS_TTL

          public static final ActionType DEC_MPLS_TTL

      Decrement MPLS TTL; Since 1.1.

    - #### PUSH_VLAN

          public static final ActionType PUSH_VLAN

      Push a new VLAN tag; Since 1.1.

    - #### POP_VLAN

          public static final ActionType POP_VLAN

      Pop the outer VLAN tag; Since 1.1.

    - #### PUSH_MPLS

          public static final ActionType PUSH_MPLS

      Push a new MPLS tag; Since 1.1.

    - #### POP_MPLS

          public static final ActionType POP_MPLS

      Pop the outer MPLS tag; Since 1.1.

    - #### SET_QUEUE

          public static final ActionType SET_QUEUE

      Set queue id when outputting to a port; Since 1.1.

    - #### GROUP

          public static final ActionType GROUP

      Apply group; Since 1.1.

    - #### SET_NW_TTL

          public static final ActionType SET_NW_TTL

      Set IP TTL; Simce 1.1.

    - #### DEC_NW_TTL

          public static final ActionType DEC_NW_TTL

      Decrement IP TTL; Since 1.1.

    - #### SET_FIELD

          public static final ActionType SET_FIELD

      Set a header field using OXM TLV format; Since 1.2.

    - #### PUSH_PBB

          public static final ActionType PUSH_PBB

      Push a new PBB service tag (I-TAG); Since 1.3.

    - #### POP_PBB

          public static final ActionType POP_PBB

      Pop the outer PBB service tag (I-TAG); Since 1.3.

    - #### EXPERIMENTER

          public static final ActionType EXPERIMENTER

      Experimenter action; Since 1.1. (Was `VENDOR` in 1.0.)

  - ### Method Detail

    - #### values

          public static ActionType[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (ActionType c : ActionType.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static ActionType valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

    - #### getCode

          public int getCode(ProtocolVersion pv)

      Description copied from interface: `OfpCodeBasedEnum`
      Returns the code for the constant, under the given protocol version.
      Specified by:
        `getCode` in interface `OfpCodeBasedEnum`
      Parameters:
        `pv` - the protocol version
      Returns:
        the code for the constant

    - #### decodeFlags

          public static Set<ActionType> decodeFlags(int bitmap,
                                    ProtocolVersion pv)

      Decodes the action type flags, based on the code associated with the flags, and returns the set of corresponding constants.
      Parameters:
        `bitmap` - the bitmap to decode
        `pv` - the protocol version
      Returns:
        the set of flags
      Throws:
        `NullPointerException` - if protocol version is null
        `VersionMismatchException` - if a bit position is not supported in the given version

    - #### encodeFlags

          public static int encodeFlags(Set<ActionType> flags,
                        ProtocolVersion pv)

      Encodes a set of action type flags as a bitmap. The `flags` parameter may be empty, in which case a bitmap of 0 (zero) is returned.
      Parameters:
        `flags` - the flags to encode
        `pv` - the protocol version
      Returns:
        the flags encoded as a bitmap
      Throws:
        `NullPointerException` - if either parameter is null
        `IllegalArgumentException` - if code associated with enumeration constant is outside the valid range (0 - 31)
        `VersionMismatchException` - if a flag is present that is not supported in the given protocol version

Copyright © 2014. All Rights Reserved.